  typedef struct {
    int_1  keys[4];       /* barker syncs(3) and packet type(1) */
    int_4  count;         /* packet number since start of xfer */
    int_4  elem;          /* data elements in packet */
    int_2  user;          /* user defined field */
    int_2  channel;       /* port channel number */
    int_1  id1,id2;       /* subsystem IDs */
    int_1  rep;           /* data rep (Vax,Ieee,Eeei) */
    int_1  bpa;           /* bytes per atom=(mode,type) */
    int_1  mode;          /* data format mode (Complex, Scalar) */
    int_1  type;          /* data format type (Pack,Byte,Int,Long) */
    int_1  tcmode;        /* timecode mode */
    int_1  tcstatus;      /* timecode status */
    double tcoff;         /* sample offset from data(1) to TC */
    double tcwsec;        /* timecode 1950 whole seconds */
    double tcfsec;        /* timecode fractional seconds */
    int_4 lval[4];        /* user fields */
  } ICEHDRSTRUCT;
  int_4  icehdrsize = sizeof(ICEHDRSTRUCT);

  typedef struct {
     int_1 fid;		/* format identifier */
     int_1 bits;	/* bits per data word 4|8|16 */
     int_2 frame;	/* frame sequence number (0x1F=parity packet) */
     int_2 tcinfo;      /* Timecode valid (0xF000) and sample offset in packet (0x0FFF) */
     int_2 tccorr;	/* Time from sample to 1msec hack in 250psec tics (min SR=60kHz) */ 
     int_8 tctics;	/* Number of 250psec tics since jan 1 to timecode hack */
     int_4 tcext;	/* Timecode extended precision (250psec/2^32) */
     int_1 sscinfo[12];	/* SSC information */
     int_1 ssdinfo[4];	/* SSD information | IP address */
     int_1 aadinfo[20];	/* AAD information */
  } SDDSHDRSTRUCT;            
  int_4  sddshdrsize = sizeof(SDDSHDRSTRUCT);
  
  typedef struct {
     int_2 keys;	/* barker packet sync 0x55AA */
     int_2 port;	/* UDP source|destination port */
     int_4 addr;	/* UDP source|destination address */ 
     int_1 fid;		/* format identifier */
     int_1 bits;	/* bits per data word 4|8|16 */
     int_2 frame;	/* frame sequence number (0x1F=parity packet) */
     int_2 tcinfo;      /* Timecode valid (0xF000) and sample offset in packet (0x0FFF) */
     int_2 tccorr;	/* Time from sample to 1msec hack in 250psec tics (min SR=60kHz) */ 
     int_8 tctics;	/* Number of 250psec tics since jan 1 to timecode hack */
     int_4 tcext;	/* Timecode extended precision (250psec/2^32) */
     int_1 sscinfo[12];	/* SSC information */
     int_1 ssdinfo[4];	/* SSD information | IP address */
     int_1 aadinfo[20];	/* AAD information */
  } RAWHDRSTRUCT;
  int_4  rawhdrsize = sizeof(RAWHDRSTRUCT);
  
  int_4  sddsdatasize   = 1024;
